(function() {
	//連絡先一覧
	var contactsList;
	
	/*
	 * 連絡先を検索
	 */
	findContact = function() {
		// ContactFindOptionsのプロパティ：
		//		filter   : String	絞り込み検索用の文字列を指定します。
		//		multiple : boolean	検索結果に複数の連絡先を返すかを指定します。
		var options = new ContactFindOptions();
		options.filter = document.getElementById("filterCondition").value;
		options.multiple = true;
		var fields = ["*"];
		applican.contacts.find(fields, findContactSuccess, findContactError, options);
	}
	
	/*
	 * 連絡先を検索成功時のCallback処理
	 */
	function findContactSuccess(contacts) {
		contactsList = contacts;
		//連絡先一覧を表示
		outputContactList(contacts);
		document.getElementById("divContactsList").style.display = "";
		//連絡先詳細を非表示
		document.getElementById("divContactsDetail").style.display = "none";
	}
	
	/*
	 * 連絡先を検索失敗時のCallback処理
	 */
	function findContactError() {
		alert("連絡先検索に失敗しました。");
	}
	
	/*
	 * 連絡先一覧を生成する
	 */
	function outputContactList(contacts) {
		var dump = "";
		var delButtons;
		var updButtons;
		var imgSrc = "img/photo.jpg";
		if(contacts.length == 0) {
			document.getElementById("divContactsList").innerHTML="連絡先なし";
			return;
		}
		
		//連絡先一覧生成
		for (var i = 0; i < contacts.length; i++) {
			dump += "<tr>";
			//写真
			dump += "<td>";
			if(contacts[i].photos && contacts[i].photos.length > 0 && contacts[i].photos[0].value){
				dump += "<img width=\"50\" height=\"50\" class=\"img-thumbnail\" src=\"" + contacts[i].photos[0].value + "\">";
			} else {
				dump += "<img width=\"50\" height=\"50\" class=\"img-thumbnail\" src=\"" + imgSrc + "\">";
			}
			dump += "</td>";
			//表示名
			dump += "<td>";
			dump += "<span>" + contacts[i].displayName + "</span>";
			dump += "</td>";
			//インデックス
			dump += "<td>";
			dump += "<input type=\"hidden\" value=\"" + i + "\" >";
			//ボタン（編集、削除）
			dump += "<button type=\"button\" onclick=\"updateContact();\" class=\"btn btn-sm btn-primary\">編集</button>";
			dump += "<button type=\"button\" onclick=\"removeContact();\" class=\"btn btn-sm btn-danger\">削除</button>";
			dump += "</td>";
			dump += "</tr>";
		}
		document.getElementById("divContactsList").innerHTML = "<table class=\"table table-striped\">" + dump + "</table>";
	}
	
	/*
	 * 連絡先を削除する
	 */
	removeContact = function() {
		var index = event.srcElement.parentElement.getElementsByTagName("input")[0].value;
		contactsList[index].remove(removeContactSuccess, removeContactError);
	}
	
	/*
	 * 連絡先を削除成功時のCallback処理
	 */
	function removeContactSuccess() {
		alert("連絡先を削除しました。");
		//連絡一覧を再作成
		findContact();		
	}
	
	/*
	 * 連絡先を削除失敗時のCallback処理
	 */
	function removeContactError() {
		alert("連絡先を削除に失敗しました。");
	}
	
	/*
	 * 連絡先を編集する
	 */
	updateContact = function() {
		var index = event.srcElement.parentElement.getElementsByTagName("input")[0].value;
		setContact(contactsList[index]);
		document.getElementById("divContactsList").style.display = "none";
		document.getElementById("searchContactsList").style.display = "none";		
		document.getElementById("divContactsDetail").style.display = "";
	}
	
	/*
	 * 連絡先詳細情報を画面に設定する
	 */
	function setContact(contactInfo) {
		if(contactInfo){
			//名前
			document.getElementById("displayName").value = contactInfo.displayName;
			document.getElementById("nickname").value = contactInfo.nickname;
			var name = contactInfo.name;
			document.getElementById("givenName").value = name.givenName;
			document.getElementById("familyName").value = name.familyName;
			
			//携帯
			var phoneNumbers = contactInfo.phoneNumbers;
			if(phoneNumbers && phoneNumbers.length > 0){
				document.getElementById("phone01").value = phoneNumbers[0].value;
			}
			if(phoneNumbers && phoneNumbers.length > 1){
				document.getElementById("phone02").value = phoneNumbers[1].value;
			}
			
			//住所
			if(contactInfo.addresses && contactInfo.addresses.length > 0){
				var address = contactInfo.addresses[0];
				document.getElementById("addressStreetAddress").value = address.streetAddress;
				document.getElementById("addressLocality").value = address.locality;
				document.getElementById("addressRegion").value = address.region;
				document.getElementById("addressPostalCode").value = address.postalCode;
				document.getElementById("addressCountry").value = address.country;
			}

			//組織
			if(contactInfo.organizations && contactInfo.organizations.length > 0){
				var organization = contactInfo.organizations[0];
				document.getElementById("organizationType").value = organization.type;
				document.getElementById("organizationName").value = organization.name;
				document.getElementById("organizationDepartment").value = organization.department;
				document.getElementById("organizationTitle").value = organization.title;
			}
			
			//写真
			if(contactInfo.photos && contactInfo.photos.length > 0){
				document.getElementById('photoImg').src = contactInfo.photos[0].value
			}
			
			//メモ
			document.getElementById("note").value = contactInfo.note;
		}
	}
})();