(function() {
	/*
	 * 連絡先を検索する
	 */
	findContactAndUpdate = function() {
		// ContactFindOptionsのプロパティ：
		//		filter: String	絞り込み検索用の文字列を指定します。
		//		multiple: boolean	検索結果に複数の連絡先を返すかを指定します。
		var options = new ContactFindOptions();
		options.filter = document.getElementById("displayName").value
		options.multiple = false;
		var fields = ["*"];
		
		// 連絡先を検索成功の場合、更新を行う
		applican.contacts.find(fields, updateContact, updateContactError, options);
	}
	
	/*
	 * 連絡先を更新する
	 */
	function updateContact(contacts) {
		if(contacts != null && contacts.length > 0) {
			//名前
			var name = new ContactName();
			name.givenName   = document.getElementById("givenName").value;
			name.familyName  = document.getElementById("familyName").value;
			contacts[0].name = name;
			
			//住所
			var address = new ContactAddress();
			address.pref          = false;
			address.type          = "home";
			address.formatted     = "";
			address.streetAddress = document.getElementById("addressStreetAddress").value;
			address.locality      = document.getElementById("addressLocality").value;
			address.region        = document.getElementById("addressRegion").value;
			address.postalCode    = document.getElementById("addressPostalCode").value;
			address.country	      = document.getElementById("addressCountry").value;
			contacts[0].addresses = [address];
			
			//携帯
			var phone = new ContactField("work", document.getElementById("phone01").value, false);
			var phone2 = new ContactField("home", document.getElementById("phone02").value, false);
			contacts[0].phoneNumbers = [phone, phone2];
			
			//組織
			var organization = new ContactOrganization();
			organization.type         = document.getElementById("organizationType").value;
			organization.name         = document.getElementById("organizationName").value;
			organization.department   = document.getElementById("organizationDepartment").value;
			organization.title        = document.getElementById("organizationTitle").value;
			contacts[0].organizations = [organization];
			
			//写真
			var photo = new ContactField("url", document.getElementById('photoImg').src);
			contacts[0].photos = [photo];
			
			//メモ
			contacts[0].note = document.getElementById("note").value;
			
			//保存
			contacts[0].save(updateContact_success, updateContactError);
		} else {
			alert("連絡先が存在しない");
		}
	}
	
	/*
	 * 連絡先を更新成功時のcallback処理
	 */
	function updateContact_success() {
		alert("連絡先を更新しました。");
		closeWebview();
	}
	
	/*
	 * 連絡先を更新失敗時のcallback処理
	 */
	function updateContactError() {
		alert("連絡先を更新に失敗しました。");
		closeWebview();
	}
	
	/*
	 * 画面を閉じる
	 */
	function closeWebview() {
		location.href = "?close_webview=yes";
	}
})();